/*
* --------------------------------------------------------------------
*
*
*
* --------------------------------------------------------------------
*/

#ifndef __CRYPTO_H__
#define __CRYPTO_H__

#define UNCACHED_MALLOC(x)  (void *) (0xa0000000 | (uint32) rtlglue_malloc(x))
#define UNCACHED_FREE(x)  rtlglue_free( (void *) (~0x20000000 & (uint32) x ) )

#include <rtl_glue.h>

#define IDLE_CPU() \
	do {\
		asm( "\
			nop; nop; nop; nop; nop; nop; nop; nop; \
			nop; nop; nop; nop; nop; nop; nop; nop; \
			"); \
	} while (0) 

#endif// __CRYPTO_H__
