/*
* --------------------------------------------------------------------
*
*
* --------------------------------------------------------------------
*/

#ifndef AUTHSIM_H
#define AUTHSIM_H

#include <rtl_types.h>

int32 authSim_md5(uint8 * data, uint32 dataLen, uint8 * digest);
int32 authSim_sha1(uint8 * data, uint32 dataLen, uint8 * digest);
int32 authSim_hmacMd5(uint8 * data, uint32 dataLen, uint8 * key, uint32 keyLen, uint8 * digest);
int32 authSim_hmacSha1(uint8 * data, uint32 dataLen, uint8 * key, uint32 keyLen, uint8 * digest);

#define SWHASH_MD5			0x00
#define SWHASH_SHA1		0x01
#define SWHMAC_MD5		0x02
#define SWHMAC_SHA1		0x03
int32 authSim(uint32 mode, uint8 * data, uint32 dataLen, uint8 * key, uint32 keyLen, uint8 * digest);
int32 authSimBatch(uint32 mode, uint8 ** data, uint32 * dataLen, uint8 ** key, uint32 * keyLen, uint8 ** digest, uint32 dataNum);

#endif

