/*
 *
 */

#ifndef _RTL_FLASHDRV_H_
#define _RTL_FLASHDRV_H_



typedef struct flashdriver_obj_s {
	uint32  flashSize;
	uint32  flashBaseAddress;
	uint32 *blockBaseArray_P;
	uint32  blockBaseArrayCapacity;
	uint32  blockNumber;
} flashdriver_obj_t;



/*
 * FUNCTION PROTOTYPES
 */
void _init( void );
uint32 flashdrv_getDevSize( void );
uint32 flashdrv_eraseBlock( uint32 ChipSeq, uint32 BlockSeq );
uint32 flashdrv_read (void *dstAddr_P, void *srcAddr_P, uint32 size);
uint32 flashdrv_write(void *dstAddr_P, void *srcAddr_P, uint32 size);



#endif  /* _RTL_FLASHDRV_H_ */

