/*
*/

#ifndef _CLE_USERGLUE_
#define _CLE_USERGLUE_

#ifdef RTL865X_MODEL_USER

	#include <stdio.h>
	#include <stdlib.h>
	#include <string.h>
	#include <stdarg.h>
	#include "rtl865x/rtl_utils.h"
	#define printk printf
	#define read_c0_status() 0
	#define write_c0_status(dummy) do {} while (0)

	#define rtl865x_pci_ioread8( addr ) 0
	#define rtl865x_pci_ioread16( addr ) 0
	#define rtl865x_pci_ioread32( addr ) 0
	#define rtl865x_pci_iowrite8( addr, val) do {} while (0)
	#define rtl865x_pci_iowrite16( addr, val) do {} while (0)
	#define rtl865x_pci_iowrite32( addr, val) do {} while (0)

	#define rtlglue_malloc malloc
	#define rtlglue_free free
	#define simple_strtol strtoul

int cle_userglue_init( void );
int cle_userglue_read( char *buf, unsigned long maxlen, char* cmd, char ch );
int cle_userglue_write( char *ubuf, unsigned long count );

#endif/*RTL865X_MODEL_USER*/

#endif/*_CLE_USERGLUE_*/
