/*
*
*
*
*/

#ifndef _RTL8651_ALG_CUSEEME
#define _RTL8651_ALG_CUSEEME



struct cu_header{
	uint16 	dest_family;
	uint16 	dest_port;
	uint32  	dest_addr;
	int16 	family;
	uint16 	port;
	uint32	addr;
	uint32	seq;
	uint16 	msg;
	uint16	data_type;
	uint16	packet_len;
} ;

/* Open Continue Header */
struct oc_header{
	uint16 	dest_family;
	uint16 	dest_port;
	uint32  	dest_addr;
	int16 	family;
	uint16 	port;
	uint32	addr;
	uint32	seq;
	uint16 	msg;
	uint16	data_type;
	uint16	packet_len;
	uint16 	client_count; 
	uint32	seq_no;
	char		user_name[20];
	char		stuff[4];
};

/* client info structures */
struct client_info{
	uint32		address; 
	char	       	stuff[8];
};


int32 rtl8651_l4AliasHandleCUseeMeClientOutbound(struct rtl_pktHdr *, struct ip *,struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *);
int32 rtl8651_l4AliasHandleCUseeMeClientInbound(struct rtl_pktHdr *, struct ip *,struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *);


#endif /* _RTL8651_ALG_CUSEEME */
