/*
*
*
*/

#ifndef _RTL8651_ALG_ICQ
#define _RTL8651_ALG_ICQ
#define _RTL8651_ALG_ICQ_MAX_CLIENT 5



int32 rtl8651_l4AliasHandleIcqClientOutbound(struct rtl_pktHdr *, struct ip *,struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *);		
int32 rtl8651_l4AliasHandleIcqServerOutbound(struct rtl_pktHdr *, struct ip *,struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *);		
void  rtl8651_l4AliasIcqReInit(void);

struct icq_command
{
	uint8 id; // always 2a
	uint8 channel; //always 02
	uint16 seq;
	
	uint16 length;
	uint16 snac1; // always 01
	
	uint16 snac2; // always 1e
	uint16 flag;
	
	uint32 reference;
	uint32 tlv6; // always 00 06 00 04
	uint32 status;
	uint32 tlv8; // always 00 08 00 02
	uint16 error;
	uint16 tlv12; // always 00 0c
	
	uint16 cli2cli;
	uint16 ip[2]; //for 4 bytes alignment
	uint16 rsv; //always 00 00 
	
	uint16 port;
	uint8 tcpflag; // 01: firewall , 02: SOCKS4/5 , 04: 'normal'
	uint8 xxa;
};

struct icq_command2
{
	uint8 id; // always 2a
	uint8 channel; //always 02
	uint16 seq;
	
	uint16 length;
	uint16 snac1; // always 01
	
	uint16 snac2; // always 1e
	uint16 xxa;
};

#endif /* _RTL8651_ALG_ICQ */
