/*
 */

#ifndef _httpd_h_
#define _httpd_h_

#if defined(DEBUG) && defined(DMALLOC)
#include <dmalloc.h>
#endif

/* Basic authorization userid and passwd limit */
#define AUTH_MAX_SIZE 64

#define webs_t	request*

int websWriteBlock(request *req, char *buf, int nChars);
#define websWrite(req, fmt, args...) (so_printf(req, fmt, ## args)); 
//#define websWrite(req,format, arg...)  {	char *temp=(char *)malloc(1024); sprintf(temp,format, ##arg); websWriteBlock(req,temp,strlen(temp)); free(temp); }
#define nvram_safe_get(name)	(nvram_get(name) ? : "")
typedef char char_t;

extern int ejArgs(int argc, char **argv, char *fmt, ...);

struct ej_handler {
	char *pattern;
	int (*output)(int eid, webs_t wp, int argc, char **argv);
};
extern struct ej_handler ej_handlers[];

struct ej_nvram_handler {
	char *pattern;
	char* (*get)(char *name);
	int (*set) (char *name, char *value);
};

extern struct ej_nvram_handler nvram_handlers[];


#endif /* _httpd_h_ */
